"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateFragments = void 0;
var generators_1 = require("../generators");
var typesToParse = ['OBJECT', 'INTERFACE'];
var forbiddenTypes = ['Query', 'Mutation', 'Subscription'];
function generateFragments(schema) {
    var schemaTypes = schema.__schema.types;
    var generatedFragments = [];
    var ObjectTypes = schema.__schema.types.filter(function (f) { return f.kind === 'OBJECT'; });
    schemaTypes.forEach(function (type) {
        if (!/^_{1,2}/.test(type.name)) {
            if (typesToParse.includes(type.kind) && !forbiddenTypes.includes(type.name)) {
                var fragment = generators_1.createNormalFragment(type, ObjectTypes);
                if (fragment) {
                    var output = "export const " + fragment.foundName + "Fragment = sgtsQL` \n  fragment " + fragment.foundName + "Fragment on " + fragment.foundName + " {\n    " + fragment.fragment + "\n  }\n`;";
                    generatedFragments.push(output);
                }
            }
        }
    });
    return generatedFragments;
}
exports.generateFragments = generateFragments;
