"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.retrieveQueriesList = exports.createMethods = void 0;
var models_1 = require("../models");
var generators_1 = require("../generators");
var templates_1 = require("../templates");
exports.createMethods = function (_a) {
    var schema = _a.schema, mode = _a.mode;
    return __awaiter(void 0, void 0, void 0, function () {
        var _b, queries, mutations, subscriptions, ObjectTypes, parsedQueries, parsedMutations, parsedSubscriptions, allQueries;
        return __generator(this, function (_c) {
            _b = __read(retrieveQueriesList({
                schema: schema,
            }), 3), queries = _b[0], mutations = _b[1], subscriptions = _b[2];
            ObjectTypes = schema.__schema.types.filter(function (f) { return f.kind === 'OBJECT'; });
            parsedQueries = queries.map(function (field) {
                return generators_1.buildMethod({ field: field, type: models_1.MethodType.Query, mode: mode, ObjectTypes: ObjectTypes });
            });
            parsedMutations = mutations.map(function (field) {
                return generators_1.buildMethod({ field: field, type: models_1.MethodType.Mutation, mode: mode, ObjectTypes: ObjectTypes });
            });
            parsedSubscriptions = subscriptions.map(function (field) {
                return generators_1.buildMethod({ field: field, type: models_1.MethodType.Subscription, mode: mode, ObjectTypes: ObjectTypes });
            });
            allQueries = __spread(parsedQueries, parsedMutations, parsedSubscriptions);
            if (mode === 'react-hooks') {
                return [2, templates_1.withReactHooksTemplate(allQueries)];
            }
            else if (mode === 'vue-hooks') {
                return [2, templates_1.withVueHooksTemplate(allQueries)];
            }
            else if (mode === 'methods') {
                return [2, templates_1.withMethodsTemplate(parsedQueries, parsedMutations)];
            }
            else {
                return [2, templates_1.withDefinitionsTemplate(allQueries)];
            }
            return [2];
        });
    });
};
var regexFilter = function (field) { return !/^_{1,2}/.test(field.name); };
function retrieveQueriesList(_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    var schema = _a.schema;
    var QueryType = schema.__schema.queryType.name;
    var MutationType = (_c = (_b = schema.__schema.mutationType) === null || _b === void 0 ? void 0 : _b.name) !== null && _c !== void 0 ? _c : '';
    var SubscriptionType = (_e = (_d = schema.__schema.subscriptionType) === null || _d === void 0 ? void 0 : _d.name) !== null && _e !== void 0 ? _e : '';
    var listQueries = (_g = (_f = schema.__schema.types.find(function (f) { return f.name === QueryType; })) === null || _f === void 0 ? void 0 : _f.fields) !== null && _g !== void 0 ? _g : [];
    var listMutations = [];
    var listSubscription = [];
    if (MutationType) {
        listMutations = (_j = (_h = schema.__schema.types.find(function (f) { return f.name === MutationType; })) === null || _h === void 0 ? void 0 : _h.fields) !== null && _j !== void 0 ? _j : [];
    }
    if (SubscriptionType) {
        listSubscription = (_l = (_k = schema.__schema.types.find(function (f) { return f.name === SubscriptionType; })) === null || _k === void 0 ? void 0 : _k.fields) !== null && _l !== void 0 ? _l : [];
    }
    var queries = listQueries.filter(regexFilter);
    var mutations = listMutations.filter(regexFilter);
    var subscription = listSubscription.filter(regexFilter);
    return [queries, mutations, subscription];
}
exports.retrieveQueriesList = retrieveQueriesList;
