"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
var ora_1 = __importDefault(require("ora"));
var generators_1 = require("./generators");
var builders_1 = require("./builders");
var shared_template_1 = require("./templates/shared.template");
var parameters_store_1 = require("./store/parameters.store");
var templates_1 = require("./templates");
var generatedInterfaces = {
    codeGen: '',
    fragments: '',
    OBJECT: [],
    ENUM: [],
    METHODS_ARGS: [],
};
var transpile = ora_1.default('🔄 Transpiling GraphQL schema to Typescript interfaces');
exports.generate = function (schema, prefix, suffix, customScalars, codegenMethods, codegenReactHooks, codegenVueHooks, codegenTemplates) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, generatedEnums, generatedTypes, generatedMethodsArgs, e_1, signature, imports, modelsTemplate;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                parameters_store_1.ParametersStore.setParamaters({
                    scalars: customScalars,
                    prefix: prefix,
                    suffix: suffix,
                });
                transpile.start();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 10, , 11]);
                _a = generators_1.generateInterfaces(schema), generatedEnums = _a.generatedEnums, generatedTypes = _a.generatedTypes;
                generatedMethodsArgs = generators_1.generateMethodsArgsTypes(schema);
                generatedInterfaces.OBJECT = generatedTypes;
                generatedInterfaces.ENUM = generatedEnums;
                generatedInterfaces.METHODS_ARGS = generatedMethodsArgs;
                generatedInterfaces.fragments = builders_1.generateFragments(schema).join('\n');
                if (!codegenMethods) return [3, 3];
                return [4, codeGenerateFromConfig({
                        schema: schema,
                        mode: 'methods',
                        message: 'queries and mutations',
                        emoji: '🧬',
                    })];
            case 2:
                _b.sent();
                _b.label = 3;
            case 3:
                if (!codegenReactHooks) return [3, 5];
                return [4, codeGenerateFromConfig({
                        schema: schema,
                        mode: 'react-hooks',
                        message: 'React hooks',
                        emoji: '⚛️ ',
                    })];
            case 4:
                _b.sent();
                _b.label = 5;
            case 5:
                if (!codegenVueHooks) return [3, 7];
                return [4, codeGenerateFromConfig({
                        schema: schema,
                        mode: 'vue-hooks',
                        message: 'Vue Hooks',
                        emoji: '🅅 ',
                    })];
            case 6:
                _b.sent();
                _b.label = 7;
            case 7:
                if (!codegenTemplates) return [3, 9];
                return [4, codeGenerateFromConfig({ schema: schema, mode: 'template', message: 'templates' })];
            case 8:
                _b.sent();
                _b.label = 9;
            case 9: return [3, 11];
            case 10:
                e_1 = _b.sent();
                transpile.fail('Transpiling failed');
                return [2, Promise.reject(e_1)];
            case 11:
                transpile.succeed("\uD83D\uDCDD Schema transpiled to Typescript");
                signature = shared_template_1.sharedTemplate;
                imports = templates_1.defineImports({
                    codegenReactHooks: !!codegenReactHooks,
                    codegenVueHooks: !!codegenVueHooks,
                    codegenMethods: !!codegenMethods,
                    codegenTemplates: !!codegenTemplates,
                });
                modelsTemplate = "\n      " + signature + "\n      " + imports + "\n      " + generatedInterfaces.OBJECT.join('\n') + "\n      " + generatedInterfaces.ENUM.join('\n') + "\n      " + generatedInterfaces.METHODS_ARGS.join('\n') + "\n      " + generatedInterfaces.fragments + "\n      " + generatedInterfaces.codeGen + "\n    ";
                return [2, modelsTemplate];
        }
    });
}); };
function codeGenerateFromConfig(_a) {
    var schema = _a.schema, mode = _a.mode, message = _a.message, emoji = _a.emoji;
    return __awaiter(this, void 0, void 0, function () {
        var oraMethods, methods, e_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    oraMethods = ora_1.default("Generating " + message + "...").start();
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4, builders_1.createMethods({
                            schema: schema,
                            mode: mode,
                        })];
                case 2:
                    methods = _b.sent();
                    generatedInterfaces.codeGen = generatedInterfaces.codeGen + methods;
                    oraMethods.succeed("" + (emoji ? emoji + ' ' : '') + message + " successfully generated");
                    return [3, 4];
                case 3:
                    e_2 = _b.sent();
                    oraMethods.fail(message + " generation failed");
                    return [2, Promise.reject(e_2)];
                case 4: return [2];
            }
        });
    });
}
