"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createNormalFragment = exports.createConnectionFragment = void 0;
var utilities_1 = require("../utilities");
exports.createConnectionFragment = function (typeName, allTypes, fragment) {
    var foundType = allTypes.find(function (f) { return f.name === typeName; });
    if (foundType) {
        var outputFragment_1 = '';
        var createLines_1 = function (field) {
            var _a;
            outputFragment_1 += field.name + " ";
            var _b = utilities_1.evaluateType(field), typeName = _b.typeName, isScalar = _b.isScalar;
            if (!isScalar) {
                if (field.name === 'node') {
                    outputFragment_1 += "{" + fragment + "} ";
                }
                else {
                    outputFragment_1 += "{ ";
                    var type = allTypes.find(function (f) { return f.name === typeName; });
                    (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach(createLines_1);
                    outputFragment_1 += "} ";
                }
            }
        };
        foundType.fields.map(createLines_1);
        return outputFragment_1;
    }
    return null;
};
exports.createNormalFragment = function (type, allTypes) {
    var foundType = allTypes.find(function (f) { return f.name === type.name; });
    if (foundType) {
        var outputFragment_2 = '';
        var nestedTypes_1 = [foundType.name];
        var createLines_2 = function (field) {
            var _a;
            var _b = utilities_1.evaluateType(field), typeName = _b.typeName, isScalar = _b.isScalar, isEnum = _b.isEnum;
            if (!isScalar && !isEnum && !nestedTypes_1.includes(typeName)) {
                outputFragment_2 += field.name + " {";
                var type_1 = allTypes.find(function (f) { return f.name === typeName; });
                nestedTypes_1.push(typeName);
                (_a = type_1 === null || type_1 === void 0 ? void 0 : type_1.fields) === null || _a === void 0 ? void 0 : _a.forEach(createLines_2);
                outputFragment_2 += "} ";
            }
            else if (!nestedTypes_1.includes(typeName)) {
                outputFragment_2 += field.name + " ";
            }
        };
        foundType.fields.map(createLines_2);
        return {
            fragment: outputFragment_2,
            foundName: foundType.name,
        };
    }
    return null;
};
