"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMethodsArgsTypes = exports.generateInterfaces = void 0;
var types_generator_1 = require("./types.generator");
var builders_1 = require("../builders");
var typesToParse = ['OBJECT', 'INTERFACE'];
function generateInterfaces(schema) {
    var schemaTypes = schema.__schema.types;
    var generatedTypes = [];
    var generatedEnums = [];
    schemaTypes.forEach(function (item) {
        if (!/^_{1,2}/.test(item.name)) {
            if (typesToParse.includes(item.kind)) {
                var generatedInterface = types_generator_1.getObjectTSInterfaces(item);
                generatedTypes.push(generatedInterface);
            }
            else if (item.kind === 'INPUT_OBJECT') {
                var generatedInterface = types_generator_1.getObjectTSInterfaces(item, true);
                generatedTypes.push(generatedInterface);
            }
            else if (item.kind === 'UNION') {
                var unionTypes = types_generator_1.generateUnionType(item);
                generatedEnums.push(unionTypes);
            }
            else if (item.kind === 'ENUM') {
                var enumTypes = types_generator_1.generateEnumType(item);
                generatedEnums.push(enumTypes);
            }
        }
    });
    return {
        generatedTypes: generatedTypes,
        generatedEnums: generatedEnums,
    };
}
exports.generateInterfaces = generateInterfaces;
function generateMethodsArgsTypes(schema) {
    var _a = __read(builders_1.retrieveQueriesList({
        schema: schema,
    }), 3), queries = _a[0], mutations = _a[1], subscriptions = _a[2];
    var generatedMethodsArgs = [];
    __spread(queries, mutations, subscriptions).forEach(function (item) {
        var generatedInterface = types_generator_1.getQueriesArgsTSInterfaces(item);
        generatedMethodsArgs.push(generatedInterface);
    });
    return generatedMethodsArgs;
}
exports.generateMethodsArgsTypes = generateMethodsArgsTypes;
