"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveFile = void 0;
var ora_1 = __importDefault(require("ora"));
var prettier = __importStar(require("prettier"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var ts = __importStar(require("typescript"));
var chalk_1 = __importDefault(require("chalk"));
var mkdirp_1 = __importDefault(require("mkdirp"));
var saveModels;
function saveFile(template, output, jsMode) {
    return __awaiter(this, void 0, void 0, function () {
        var pretty, prettierFoundOptions, message, formatedModelsFile, outputfile, content, dirList, dirPath, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 7, , 8]);
                    pretty = ora_1.default('\nRunning Prettier with your config on the generated output').start();
                    return [4, prettier.resolveConfig(process.cwd())];
                case 1:
                    prettierFoundOptions = _a.sent();
                    message = 'using your Prettier config';
                    if (!prettierFoundOptions) {
                        message = 'using default Prettier config';
                        prettierFoundOptions = {
                            printWidth: 100,
                            tabWidth: 2,
                            trailingComma: 'es5',
                            singleQuote: true,
                            semi: true,
                            bracketSpacing: true,
                            htmlWhitespaceSensitivity: 'strict',
                        };
                    }
                    formatedModelsFile = prettier.format(template, __assign(__assign({}, prettierFoundOptions), { parser: 'typescript' }));
                    pretty.succeed("\uD83D\uDC84 Your file has been formated " + message);
                    if (!output) return [3, 6];
                    outputfile = path_1.default.resolve(process.cwd(), output);
                    if (!fs_1.default.existsSync(outputfile)) return [3, 3];
                    return [4, writeOutput(outputfile, formatedModelsFile, jsMode)];
                case 2:
                    content = _a.sent();
                    return [2, content];
                case 3:
                    dirList = outputfile.split('/');
                    dirList.pop();
                    dirPath = dirList.join('/');
                    return [4, mkdirp_1.default(dirPath)];
                case 4:
                    _a.sent();
                    return [4, writeOutput(outputfile, formatedModelsFile, jsMode)];
                case 5: return [2, _a.sent()];
                case 6: return [2, formatedModelsFile];
                case 7:
                    e_1 = _a.sent();
                    return [2, Promise.reject(e_1)];
                case 8: return [2];
            }
        });
    });
}
exports.saveFile = saveFile;
function TypescriptCompile(fileNames, options) {
    var program = ts.createProgram(fileNames, options);
    program.emit();
}
function writeOutput(path, content, jsMode) {
    return __awaiter(this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    saveModels = ora_1.default('Saving models file...').start();
                    return [4, fs_1.default.writeFileSync(path, content)];
                case 1:
                    _a.sent();
                    saveModels.succeed("\uD83C\uDF89 Output saved at " + chalk_1.default.bold("" + path));
                    if (jsMode) {
                        try {
                            TypescriptCompile([path], {
                                module: ts.ModuleKind.CommonJS,
                                target: ts.ScriptTarget.ESNext,
                                moduleResolution: ts.ModuleResolutionKind.NodeJs,
                                allowSyntheticDefaultImports: true,
                                experimentalDecorators: true,
                                emitDecoratorMetadata: true,
                                resolveJsonModule: true,
                                esModuleInterop: true,
                                removeComments: true,
                                noImplicitAny: false,
                                noUnusedLocals: false,
                                pretty: true,
                                sourceMap: false,
                                downlevelIteration: true,
                                declaration: true,
                                skipLibCheck: true,
                                types: ['node'],
                            });
                            fs_1.default.unlinkSync(path);
                            return [2, content];
                        }
                        catch (e) {
                            return [2, Promise.reject(e)];
                        }
                    }
                    else {
                        return [2, content];
                    }
                    return [3, 3];
                case 2:
                    e_2 = _a.sent();
                    saveModels.fail('Saving models file failed');
                    console.log(e_2.message);
                    return [2, Promise.reject('Error in saving file')];
                case 3: return [2];
            }
        });
    });
}
