"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defineImports = void 0;
var fragmentType_template_1 = require("./fragmentType.template");
exports.defineImports = function (_a) {
    var codegenReactHooks = _a.codegenReactHooks, codegenVueHooks = _a.codegenVueHooks, codegenMethods = _a.codegenMethods, codegenTemplates = _a.codegenTemplates;
    var template = '';
    if (codegenReactHooks || codegenMethods || codegenTemplates || codegenVueHooks) {
        template = "\n    import { OperationDefinitionNode } from 'graphql';\n    " + fragmentType_template_1.guessFragmentTypeTemplate + "\n    ";
        if (codegenReactHooks) {
            template += "\n      import { useMutation, useQuery, useSubscription, QueryHookOptions, MutationHookOptions, SubscriptionHookOptions, MutationTuple } from '@apollo/react-hooks'\n      ";
        }
        if (codegenVueHooks) {
            template += "\n      import { Ref } from '@vue/composition-api'\n      import { useMutation, useQuery, useSubscription, UseQueryOptions, UseMutationOptions, UseSubscriptionOptions } from '@vue/apollo-composable'\n      export type ReactiveFunction<TParam> = () => TParam;\n      ";
        }
        if (codegenMethods) {
            template += "\n      import ApolloClient, { QueryOptions, OperationVariables, MutationOptions, ObservableQuery } from 'apollo-client';\n      import { execute } from 'apollo-link';\n    ";
        }
    }
    return template;
};
