"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.areAllArgsOptional = exports.isReturnTypeEdge = exports.evaluateType = void 0;
exports.evaluateType = function (field) {
    var propertyName = field.name;
    var isRequired = false;
    var isArray = false;
    var isArrayRequired = false;
    var isEdge = false;
    var isScalar = false;
    var isEnum = false;
    var typeName = '';
    if (propertyName === 'edges')
        isEdge = true;
    function getFieldInfos(type) {
        if (type.kind === 'NON_NULL') {
            if (isArray) {
                isArrayRequired = true;
            }
            else {
                isRequired = true;
            }
        }
        if (type.kind === 'LIST') {
            isArray = true;
        }
        if (type.ofType) {
            return getFieldInfos(type.ofType);
        }
        else {
            if (type.kind === 'SCALAR') {
                isScalar = true;
            }
            else if (type.kind === 'ENUM') {
                isEnum = true;
            }
            typeName = type.name;
        }
        return null;
    }
    getFieldInfos(field.type);
    return {
        isRequired: isRequired,
        isArray: isArray,
        isArrayRequired: isArrayRequired,
        isEdge: isEdge,
        isScalar: isScalar,
        typeName: typeName,
        isEnum: isEnum,
    };
};
exports.isReturnTypeEdge = function (ObjectTypes, typeName) {
    var type = ObjectTypes.find(function (f) { return f.name === typeName; });
    if (type) {
        return type.fields.map(exports.evaluateType).some(function (s) { return s.isEdge; });
    }
    return false;
};
exports.areAllArgsOptional = function (args) {
    return args.map(exports.evaluateType).every(function (m) { return !m.isRequired; });
};
